---
title: for
slug: Web/JavaScript/Reference/Statements/for
tags:
  - JavaScript
  - Language feature
  - Loop
  - Reference
  - Statement
  - for
---
<div>{{jsSidebar("Statements")}}</div>

<p>The <strong>for statement</strong> creates a loop that consists of three optional expressions, enclosed in parentheses and separated by semicolons, followed by a statement (usually a <a href="/en-US/docs/Web/JavaScript/Reference/Statements/block">block statement</a>) to be executed in the loop.</p>

<div>{{EmbedInteractiveExample("pages/js/statement-for.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">for ([<var>initialization</var>]; [<var>condition</var>]; [<var>final-expression</var>])
   <var>statement</var></pre>

<dl>
 <dt><code><var>initialization</var></code></dt>
 <dd>An expression (including assignment expressions) or variable declaration evaluated once before the loop begins. Typically used to initialize a counter variable. This expression may optionally declare new variables with <code>var</code> or <code>let</code> keywords. Variables declared with <code>var</code> are not local to the loop, i.e. they are in the same scope the <code>for</code> loop is in. Variables declared with <code>let</code> are local to the statement.</dd>
 <dd>The result of this expression is discarded.</dd>
 <dt><code><var>condition</var></code></dt>
 <dd>An expression to be evaluated before each loop iteration. If this expression evaluates to true, <code><var>statement</var></code> is executed. This conditional test is optional. If omitted, the condition always evaluates to true. If the expression evaluates to false, execution skips to the first expression following the <code>for</code> construct.</dd>
 <dt><code><var>final-expression</var></code></dt>
 <dd>An expression to be evaluated at the end of each loop iteration. This occurs before the next evaluation of <code><var>condition</var></code>. Generally used to update or increment the counter variable.</dd>
 <dt><code><var>statement</var></code></dt>
 <dd>A statement that is executed as long as the condition evaluates to true. To execute multiple statements within the loop, use a {{jsxref("Statements/block", "block", "", 0)}} statement (<code>{ ... }</code>) to group those statements. To execute no statement within the loop, use an {{jsxref("Statements/empty", "empty", "", 0)}} statement (<code>;</code>).</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Using_for">Using for</h3>

<p>The following <code>for</code> statement starts by declaring the variable <code>i</code> and initializing it to <code>0</code>. It checks that <code>i</code> is less than nine, performs the two succeeding statements, and increments <code>i</code> by 1 after each pass through the loop.</p>

<pre class="brush: js notranslate">for (let i = 0; i &lt; 9; i++) {
   console.log(i);
   // more statements
}
</pre>

<h3 id="Optional_for_expressions">Optional for expressions</h3>

<p>All three expressions in the head of the <code>for</code> loop are optional.</p>

<p>For example, in the <code><var>initialization</var></code> block it is not required to initialize variables:</p>

<pre class="brush: js notranslate">var i = 0;
for (; i &lt; 9; i++) {
    console.log(i);
    // more statements
}
</pre>

<p>Like the <code><var>initialization</var></code> block, the <code><var>condition</var></code> block is also optional. If you are omitting this expression, you must make sure to break the loop in the body in order to not create an infinite loop.</p>

<pre class="brush: js notranslate">for (let i = 0;; i++) {
   console.log(i);
   if (i &gt; 3) break;
   // more statements
}</pre>

<p>You can also omit all three blocks. Again, make sure to use a {{jsxref("Statements/break", "break")}} statement to end the loop and also modify (increase) a variable, so that the condition for the break statement is true at some point.</p>

<pre class="brush: js notranslate">var i = 0;

for (;;) {
  if (i &gt; 3) break;
  console.log(i);
  i++;
}
</pre>

<h3 id="Using_for_without_a_statement">Using for without a statement</h3>

<p>The following <code>for</code> cycle calculates the offset position of a node in the <code><var>final-expression</var></code> section, and therefore it does not require the use of a <code><var>statement</var></code> section, a semicolon is used instead.</p>

<pre class="brush: js notranslate">function showOffsetPos(sId) {

  var nLeft = 0, nTop = 0;

  for (

    var oItNode = document.getElementById(sId); /* initialization */

    oItNode; /* condition */

    nLeft += oItNode.offsetLeft, nTop += oItNode.offsetTop, oItNode = oItNode.offsetParent /* final-expression */

  ); /* semicolon */

  console.log('Offset position of \'' + sId + '\' element:\n left: ' + nLeft + 'px;\n top: ' + nTop + 'px;');

}

/* Example call: */

showOffsetPos('content');

// Output:
// "Offset position of "content" element:
// left: 0px;
// top: 153px;"</pre>

<div class="note"><strong>Note:</strong> This is one of the few cases in JavaScript where <strong>the semicolon is mandatory</strong>. Indeed, without the semicolon the line that follows the cycle declaration will be considered a statement.</div>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-for-statement', 'for statement')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.statements.for")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Statements/empty", "empty statement", "", 0)}}</li>
 <li>{{jsxref("Statements/break", "break")}}</li>
 <li>{{jsxref("Statements/continue", "continue")}}</li>
 <li>{{jsxref("Statements/while", "while")}}</li>
 <li>{{jsxref("Statements/do...while", "do...while")}}</li>
 <li>{{jsxref("Statements/for...in", "for...in")}}</li>
 <li>{{jsxref("Statements/for...of", "for...of")}}</li>
</ul>
